/*
meparse.h

(C) 2002, Darren Wilkinson
d.j.wilkinson@ncl.ac.uk
http://www.staff.ncl.ac.uk/d.j.wilkinson/

Last edited on: $LastChangedDate: 2006-01-25 13:10:57 +0000 (Wed, 25 Jan 2006) $
by $Author: colin $
Revision: $Rev: 54 $
*/

#include <gsl/gsl_vector.h>
#include <gsl/gsl_rng.h>

/*global function declaration */
gsl_rng * get_globalr(void);

typedef enum
{
  MEPInfix,
  MEPPrefix,
  MEPConstant,
  MEPVariable,
  MEPVariableI,
  MEPVariableL,
  MEPVariableF,
  MEPVarERROR
} MEPType;

typedef union
{
  double (*in_op)(double,double);
  double (*pre_op)(double);
  double data;
  double *var;
  int *varI;
  long *varL;
  float *varF;
} MEPInfo;

typedef struct _MEPNode
{
  MEPType type;
  MEPInfo info;
  struct _MEPNode *left;
  struct _MEPNode *right;
} MEPNode;

/* function prototypes */
MEPNode * MEPParseTree(const char *formula,void * envPtr, int type, gsl_vector *localParArray[]);
void MEPFreeTree(MEPNode *tree);
double MEPEval(MEPNode *tree);
void MEPPrint(MEPNode *tree);

/* user-defined callback function */
void MEPMkVarPtr(char * varName,MEPNode * varNode,void * envPtr,int type, gsl_vector *localParArray[]); 

/* eof */

